import { XMLParser as x } from "fast-xml-parser";
import * as d from "he";
const N = (t) => {
  var a, o;
  if (typeof t == "string")
    return {
      message: "",
      type: "",
      content: t
    };
  const r = ((a = t.__attr) == null ? void 0 : a.message) ?? "", e = ((o = t.__attr) == null ? void 0 : o.type) ?? "", s = d.decode(t.__text ?? "");
  return {
    message: r,
    type: e,
    content: s
  };
}, g = (t) => {
  var a, o, i;
  const r = {
    id: (a = t.__attr) != null && a.id ? parseInt(t.__attr.id) : void 0,
    name: (o = t.__attr) == null ? void 0 : o.name,
    time: (i = t.__attr) == null ? void 0 : i.time
  }, { failure: e, error: s } = t;
  if (e instanceof Array)
    throw new Error("<testcase> should have one <failure> tag");
  if (r.failure = e ? N(e) : void 0, s instanceof Array)
    throw new Error("<testcase> should have one <failure> tag");
  return r.error = s ? N(s) : void 0, r;
}, p = (t) => {
  var a, o, i, n, _, u, f;
  let r;
  "testsuite" in t && (r = h(t));
  const e = {
    id: (a = t.__attr) != null && a.id ? parseInt(t.__attr.id) : void 0,
    name: (o = t.__attr) == null ? void 0 : o.name,
    time: (i = t.__attr) == null ? void 0 : i.time,
    properties: {},
    tests: [],
    failures: (n = t.__attr) != null && n.failures ? parseInt(t.__attr.failures) : NaN,
    errors: (_ = t.__attr) != null && _.errors ? parseInt(t.__attr.errors) : 0,
    systemOut: ((u = t["system-out"]) == null ? void 0 : u.__text) ?? (typeof t["system-out"] == "string" ? t["system-out"] : void 0),
    systemErr: ((f = t["system-err"]) == null ? void 0 : f.__text) ?? (typeof t["system-err"] == "string" ? t["system-err"] : void 0),
    testReport: r
  }, s = t.testcase;
  return s instanceof Array ? e.tests = s.map(g) : s && e.tests.push(g(s)), isNaN(e.failures) && (e.failures = e.tests.reduce(
    (m, l) => m + (l.failure ? 1 : 0),
    0
  )), e;
}, h = (t) => {
  var s, a, o, i, n, _, u;
  const r = {
    id: (s = t.__attr) != null && s.id ? parseInt(t.__attr.id) : void 0,
    package: (a = t.__attr) == null ? void 0 : a.package,
    name: (o = t.__attr) == null ? void 0 : o.name,
    time: (i = t.__attr) == null ? void 0 : i.time,
    tests: (n = t.__attr) != null && n.tests ? parseInt(t.__attr.tests) : NaN,
    failures: (_ = t.__attr) != null && _.failures ? parseInt(t.__attr.failures) : NaN,
    errors: (u = t.__attr) != null && u.errors ? parseInt(t.__attr.errors) : 0,
    suites: []
  }, e = t.testsuite;
  if (e instanceof Array ? r.suites = e.map(p) : e && r.suites.push(p(e)), isNaN(r.tests) || isNaN(r.failures)) {
    const [f, m, l] = r.suites.reduce(
      ([v, w, I], c) => {
        var y;
        return [
          v + c.tests.length + (((y = c.testReport) == null ? void 0 : y.tests) ?? 0),
          w + c.failures,
          I + (c.errors ?? 0)
        ];
      },
      [0, 0, 0]
    );
    r.tests = f, r.failures = m, r.errors = l;
  }
  return r;
}, A = (t) => new x({
  attributesGroupName: "__attr",
  textNodeName: "__text",
  attributeNamePrefix: "",
  ignoreAttributes: !1,
  removeNSPrefix: !1,
  allowBooleanAttributes: !0,
  attributeValueProcessor: (e, s) => d.decode(s, { isAttributeValue: !0 }),
  //default is a=>a
  tagValueProcessor: (e, s) => d.decode(s),
  //default is a=>a
  stopNodes: ["failure", "error", "system-out", "system-err"]
}).parse(t), E = (t) => {
  var s;
  const r = A(t);
  if (r.testsuite) {
    const a = p(r.testsuite);
    return {
      id: a.id,
      name: a.name,
      time: a.time,
      tests: a.tests.length + (((s = a.testReport) == null ? void 0 : s.tests) ?? 0),
      failures: a.failures,
      errors: a.errors,
      suites: [a]
    };
  }
  const e = r.testsuites;
  if (!e)
    throw new Error("empty test report");
  if (e instanceof Array)
    throw new Error("root should have a single node of <testsuites>");
  return h(e);
};
export {
  E as parseJUnitTestReport,
  N as visitFailure
};
