import type { JUnitFailure, JUnitTestReport } from './types.js';
interface XMLNode {
    __attr?: Record<string, string>;
    __text?: string;
    testsuite?: XMLNode;
    [children: string]: unknown;
}
export declare const visitFailure: (failure: XMLNode | string) => JUnitFailure;
export declare const parseJUnitTestReport: (xmlData: string) => JUnitTestReport;
export {};
